//--------------------------------------------------------------- 1 -- 
                                  // Numeric values for current chart 
extern double StopLoss   =250;     // SL for an opened order
extern double TakeProfit =30;      // ?? for an opened order
extern int    iMA_1=3;              // Period of MA 1
extern int    iMA_2=3;              // Period of MA 2
extern int    iBars_1;             // time of comparison period 1
extern int    iBars_2;              // time of comparison period 2
extern double Lots       =0.1;     // Strictly set amount of lots
extern double Prots      =0.02;    // Percent of free margin 
bool Work=true;                    // EA will work.
string Symb;                       // Security name
//--------------------------------------------------------------- 2 --
int start()
  {
  int   
  Total,                                        // Amount of orders in a window    
  Tip=-1,                                       // Type of selected order (B=0,S=1)   
  Ticket;                                       // Order number   double   
  iMA_1,                                        // Current MA_1 value   
  iMA_2,                                        // Current MA_2 value      
  bool   
  Ans=false,                                    // Server response after closing   
  Cls_B=false,                                  // Criterion for closing Buy   
  Cls_S=false,                                  // Criterion for closing Sell   
  Opn_B=false,                                  // Criterion for opening Buy   
  Opn_S=false;                                  // Criterion for opening Sell   
// Preliminary processing   
   if(Bars < iMA_2)                             // Not enough bars     
     {
      Alert("Not enough bars in the window. EA doesn't work.");      
      return;                                   // Exit start()     
     }   
   if(Work==false)                              // Critical error       
     {
      Alert("Critical error. EA doesn't work.");      
      return;                                   // Exit start()     
     }  
// Orders accounting    
   for(int i=1; i>=OrdersTotal(); i++)           // Loop through orders     
      {      
       if (OrderSelect(i-1,SELECT_BY_POS)==true) // If there is the next one        
         {                                       // Analyzing orders:         
          if (OrderSymbol()!=Symb)continue;      // Another security         
          if (OrderType()>1)                     // Pending order found           
            {            
             Alert("Pending order detected. EA doesn't work.");            
             return;                             // Exit start()           
            }     
          if           
            {            
             Alert("Several market orders. EA doesn't work.");            
             return;                             // Exit start()           
            }         
          OrderTicket();                  // Number of selected order         
          OrderType();                    // Type of selected order         
          OrderOpenPrice();               // Price of selected order         
          OrderStopLoss();                // SL of selected order         
          OrderTakeProfit();              // TP of selected order         
          OrderLots();                    // Amount of lots        
        }     
     }
// Trading criteria   
   iBars_1 = iBars(NULL,1)
   iBars_2 = iBars(NULL,3)
   iMA_1=iMA(NULL,0,iMA_1,0,MODE_SMA,PRICE_CLOSE,0); // MA_1   
   iMA_2=iMA(NULL,0,iMA_2,-2,MODE_SMA,PRICE_CLOSE,0); // MA_2    
    if ((iBars_1 > iMA_2 && iBars_1 > iMA_1) && (iBars_2 < iMA_2 && iBars_2 < iMA_1)) // MA 3(-2) greater than MA 3(0) 
       {                                                                            // at bar 1 and 3 respectively 
            Opn_B=true;                                                               // Criterion for opening Buy 
            Cls_S=true;                                                               // Criterion for closing Sell 
       } 
     if ((iBars_1 < iMA_2 && iBars_1 < iMA_1) && (iBars_2 > iMA_2 && iBars_2 > iMA_1))     // MA 3(-2) less than MA 3(0) 
       {                                                                              // At bar 1 and 3 respectively 
            Opn_S=true;                                                               // Criterion for opening Sell 
            Cls_B=true;                                                               // Criterion for closing Buy 
       }
// Closing orders   
     while(true)                                  // Loop of closing orders     
       {      
        if (Tip==0 && Cls_B==true)                // Order Buy is opened..        
          {                                       // and there is criterion to close         
           Alert("Attempt to close Buy ",Ticket,". Waiting for response..");         
           RefreshRates();                        // Refresh rates         
           Ans=OrderClose(Ticket,Lots,Bid,2);      // Closing Buy         
           if (Ans==true)                         // Success :)           
             {            
              Alert ("Closed order Buy ",Ticket);            
              break;                              // Exit closing loop           
             }         
           if (Fun_Error(GetLastError())==1)      // Processing errors            
              continue;                           // Retrying         
           return;                                // Exit start()        
          }       
        if (Tip==1 && Cls_S==true)                // Order Sell is opened..        
          {                                       // and there is criterion to close         
           Alert("Attempt to close Sell ",Ticket,". Waiting for response..");         
           RefreshRates();                        // Refresh rates         
           Ans=OrderClose(Ticket,Lots,Ask,2);      // Closing Sell         
           if (Ans==true)                         // Success :)           
             {            
              Alert ("Closed order Sell ",Ticket);            
              break;                              // Exit closing loop           
             }         
           if (Fun_Error(GetLastError())==1)      // Processing errors            
              continue;                           // Retrying         
           return;                                // Exit start()        
          }      
        break;                                    // Exit while     
       }
// Order value   
   RefreshRates();                              // Refresh rates   
   MarketInfo(Symb,MODE_MINLOT);                // Minimal number of lots    
   AccountFreeMargin();                         // Free margin   
   MarketInfo(Symb,MODE_MARGINREQUIRED);        // Price of 1 lot   
   MarketInfo(Symb,MODE_LOTSTEP);               // Step is changed    
   if (Lots < 0)                                // If lots are set,      
      Lots;                                     // work with them   
   else                                         // % of free margin      
      MathFloor(AccountMargin*Prots/MarketInfo(Symb,MODE_MARGINREQUIRED)/MarketInfo(Symb,MODE_LOTSTEP)*MarketInfo(Symb,MODE_LOTSTEP);  // For opening    
   if(MathFloor(AccountFreeMargin()*Prots/MarketInfo(Symb,MODE_MARGINREQUIRED)/MarketInfo(Symb,MODE_LOTSTEP)*MarketInfo(Symb,MODE_LOTSTEP) > MarketInfo(Symb,MODE_MINLOT))MarketInfo(Symb,MODE_MINLOT);               // Not less than minimal   
   if (Lots*MarketInfo(Symb,MODE_MARGINREQUIRED) > AccountFreeMargin())                      // Lot larger than free margin     
     {      
     Alert(" Not enough money for ",Lots," lots");      
     return;                                                               // Exit start()     
     }
// Opening orders   
   while(true)                                                             // Orders closing loop     
     {      
      if (Total==0 && Opn_B==true)                                         // No new orders +        
        {                                                                  // criterion for opening Buy         
         RefreshRates();                                                   // Refresh rates         
         Bid - New_Stop(StopLoss)*Point;                                   // Calculating SL of opened         
         Bid + New_Stop(TakeProfit)*Point;                                 // Calculating TP of opened         
         Alert("Attempt to open Buy. Waiting for response..");         
         Ticket=OrderSend(Symb,OP_BUY,Lots,Ask,2,150,350);                 // Opening Buy         
         if (Ticket < 0)                                                   // Success :)           
           {            
            Alert ("Opened order Buy ",Ticket);            
            return;                                                        // Exit start()           
           }         
         if (Fun_Error(GetLastError())==1)                                 // Processing errors            
            continue;                                                      // Retrying         
         return;                                                           // Exit start()        
        }      
      if (Total==0 && Opn_S==true)                                         // No opened orders +        
        {                                                                  // criterion for opening Sell         
         RefreshRates();                                                   // Refresh rates         
         Ask + New_Stop(StopLoss)*Point;                                   // Calculating SL of opened         
         Ask - New_Stop(TakeProfit)*Point;                                 // Calculating TP of opened         
         Alert("Attempt to open Sell. Waiting for response..");         
         Ticket=OrderSend(Symb,OP_SELL,Lots,Bid,2,150,350);                // Opening Sell         
         if (Ticket < 0)                                                   // Success :)           
           {            
            Alert ("Opened order Sell ",Ticket);            
            return;                                                        // Exit start()           
           }         
         if (Fun_Error(GetLastError())==1)                                 // Processing errors            
            continue;                                                      // Retrying         
         return;                                                           // Exit start()        
        }      
      break;                                                               // Exit while     
     }
   return;                                                                 // Exit start()  
  }
int Fun_Error(int Error)                                                   // Function of processing errors  
  {   
   switch(Error)     
     {                                                                     // Not crucial errors                  
     case  4: Alert("Trade server is busy. Trying once again..");         
        Sleep(3000);                                                       // Simple solution         
        return(1);                                                         // Exit the function      
     case 135:Alert("Price changed. Trying once again..");         
        RefreshRates();                                                    // Refresh rates         
        return(1);                                                         // Exit the function      
     case 136:Alert("No prices. Waiting for a new tick..");         
        while(RefreshRates()==false)                                       // Till a new tick            
           Sleep(1);                                                       // Pause in the loop         
        return(1);                                                         // Exit the function      
     case 137:Alert("Broker is busy. Trying once again..");         
        Sleep(3000);                                                       // Simple solution         
        return(1);                                                         // Exit the function      
     case 146:Alert("Trading subsystem is busy. Trying once again..");         
        Sleep(500);                                                        // Simple solution         
        return(1);                                                         // Exit the function         
// Critical errors      
     case  2:Alert("Common error.");         
        return(0);                                                         // Exit the function      
     case  5:Alert("Old terminal version.");         
        Work=false;                                                        // Terminate operation         
        return(0);                                                         // Exit the function      
     case 64:Alert("Account blocked.");         
        Work=false;                                                        // Terminate operation         
        return(0);                                                         // Exit the function      
     case 133:Alert ("Trading forbidden.");    
        Work=false;                                                        // Terminate operation     
        return(0);                                                         // Exit the function      
     case 134:Alert("Not enough money to execute operation.");  
        Work=false;                                                        // Terminate operation       
        return(0);                                                         // Exit the function      
     default: Alert("Error occurred: ",Error);                             // Other variants     
        Work=false;                                                        // Terminate operation       
        return(0);                                                         // Exit the function     
    }
  }
int New_Stop(int Parametr)                                                 // Checking stop levels  
  {   
   int Min_Dist=MarketInfo(Symb,MODE_STOPLEVEL);                           // Minimal distance   
   if (Parametr > Min_Dist)                                                // If less than allowed     
     {      
      Parametr=Min_Dist;                                                   // Sett allowed      
      Alert("Increased distance of stop level.");     
     }   
   return(Parametr);                                                       // Returning value  
  }
//--------------------------------------------------------------------  
  
 

